$startPath = "{Start Folder from "Initialize Data"}"
$ancestors = {Ancestor Count from "Initialize Data"}
$childPath = "{Child Folder Path from "Initialize Data"}"

$Action = "Get Relative Folder"
$ErrorState = 0
$ErrorMessage = ""
$Trace = "Starting $Action`n`n"

try
{
    if (!$childPath.StartsWith("\"))
    {
       $childPath = "\" + $childPath
    }

    $Trace += "Validating $startPath exists `r`n"
    $directory = [System.IO.DirectoryInfo]$startPath

    $Trace += "Getting $ancestors directory parents`r`n"
    while ($ancestors -gt 0) 
    {
        $directory = $directory.Parent
        $ancestors--
    }

    $Trace += "Appending $childPath to new path and validating existance`r`n"
    $newPath = $directory.FullName + $childPath
    $newDirectory = [System.IO.DirectoryInfo]$newPath
    if (!$newDirectory.Exists)
    {
        throw "New path not found! $newPath"
    }

    $Trace += "Completing $Action`r`n"
    $DirectoryPath = $newDirectory.FullName
}
catch
{
    $ErrorState = 2
    $ErrorMessage = $error[0].Exception.tostring()
    $Trace += "Error caught in $Action`r`n"
}
finally
{
    $Trace += "Exiting $Action `r`n"
    $Trace += "ErrorState:   $ErrorState`r`n"
    $Trace += "ErrorMessage: $ErrorMessage`r`n" 
}
