# subscribe to published data here
$variable1 = "{variable1 from "Initialize Data"}" 
$variable2 = "{variable2 from "Initialize Data"}"

# set trace and status variables to defaults
$ErrorState = 0
$ErrorMessage = ""
$Trace = ""
$Error.Clear()

# validate inputs
if (($variable1.length -lt 1) -or ($variable2.length -lt 1)) 
{
      Throw "Error: One or more required parameters is Null."        
}

# establish the PS remote session
$Session = New-PSSession -ComputerName $SCOMServerFQDN 
if ($Session -eq $null) 
{
    $ErrorMessage =  $Error[0]
    $Trace += "Could not create PSSession on $SCOMServerFQDN"
    $ErrorState = 2
}
else
{
   # execute script in remote session
   $ReturnArray = Invoke-Command -Session $Session 
   -Argumentlist $variable1, $variable2 -ScriptBlock {
        Param ( $variable1, $variable2 )

    # use try/catch/finally
    try
    {
        # append useful data to the trace variable
        $Action = 'My Action';
        $Trace = "Beginning remote action '$Action' `r`n"     
        $Trace += "Parameters:`r`n"
        $Trace += "  Variable1:  $variable1 `r`n"
        $Trace += "  Variable2:  $variable2 `r`n"
        $Trace += "`r`n"

        #import any required Windows PowerShell modules here

        #perform core task logic here
      
        #set ErrorState and ErrorMessage
        $ErrorState = 0   #Return Success
        $Trace += "Completed remote action '$Action'... `r`n"
    }
    catch
    {
        $Trace += "Exception caught in remote action '$Action'... `r`n"
        $ErrorState = 2
        $ErrorMessage = $error[0].Exception.tostring()
    }
    finally
    {
        $Trace += "Exiting remote action '$Action' `r`n"
        $Trace += "ErrorState:   $ErrorState`r`n"
        $Trace += "ErrorMessage: $ErrorMessage`r`n" 
    }
    
    # return results
    $Results = @($ErrorState, $ErrorMessage, $Trace)     
    Return $Results
  }
  
  # prep data for Orchestrator publishing
  $ErrorState = $ReturnArray[0]
  $ErrorMessage = $ReturnArray[1]
  $Trace = $ReturnArray[2]

  # close remote session
  Remove-PSSession -Session $Session
}
