# returning arrays local
[xml]$node = $groupNode

$MPs = @()
$ClassNames = @()
$FilterProperty = @()
$FilterWith = @()

foreach ($classNode in $node.Group.Class)
{
    $MPs += $classNode.MP
    $ClassNames += $classNode.Name
    $FilterProperty += $classNode.FilterProperty
    $FilterWith += $classNode.FilterWith   
}

# returning arrays remote
$ReturnArray = Invoke-Command -Session $Session -Argumentlist $VMMServerFQDN -ScriptBlock {
    Param ( $VMMServerFQDN )

    Import-Module VirtualMachineManager
    
         $VMMServer = Get-SCVMMServer -ComputerName $VMMServerFQDN

    $roleNames = @()
    $roles = Get-SCUserRole 
    foreach ($role in $roles)
    {
        $roleNames += $role.Name
    }

    $Results = @($ErrorState, $ErrorMessage, $Trace, $roleNames)     
    Return $Results
    
} #End remote execution

$ErrorState = $ReturnArray[0]
$ErrorMessage = $ReturnArray[1]
$Trace = $ReturnArray[2]
$Names = $ReturnArray[3]

#Reprocessing the array locally for Orchestrator
$RoleNames = @()

foreach ($name in $Names)
{
   $RoleNames += $name
}
