#Inputs from published data
$Hosts= vmm01;sco01;sco02"

$HostList = @()
$HostList = $Hosts.split(",",[stringsplitoptions]::RemoveEmptyEntries)

$ErrorState = 2
$ErrorMessage = ""
$Trace = ""
$Error.Clear()

# -----------------------------------------------------------
Function TestPSRemoting {
	Param ( [string]$HostName )
        
        $ErrorState = 0
        $ErrorMessage = ""
        $Trace = ""
        $Error.Clear()
         
        Try
        {
            $IPAddressFromDNS = [System.Net.Dns]::GetHostAddresses($HostName)
            $Trace += $IPAddressFromDNS + " `r`n"  
            $Trace += "Attempting Invoke-Command -ComputerName $HostName `r`n"
            $ErrorActionPreference = "Stop" 
            $Result = Invoke-Command -ComputerName $HostName { 0 }
            If ($Result -eq 0) {
                $Trace += "Successfully connected to $HostName `r`n"
                $ErrorState = 0
            }
        }
        Catch
        {
            $ErrorState = 2
            $ErrorMessage = $error[0].Exception.ToString()
        }
        Finally
        {
            $Trace += "ErrorState:     $ErrorState `r`n"
            $Trace += "ErrorMessage:   $ErrorMessage `r`n"
               #write-host $ErrorState
        }
        $ResultArray = @($ErrorState, $ErrorMessage, $Trace)
        Return $ResultArray
}
#---------------------------------------------------------------

$Trace = "Beginning BatchTest-PSRemoting... `r`n"     
$Trace += "`r`n"
$Trace += "Host(s):   $Hosts`r`n"
$Trace += "`r`n"

$serverResultList = @()
$ResultList = @{}
$unreachableServerCount=0
$reachableServerCount=0
$isReachable = $true

foreach($x in $HostList)
{
    $ResultList = TestPSRemoting($x)
    if($ResultList[0] -ne '0') 
    { 
        $isReachable = $false 
        $unreachableServerCount++
        $serverResultList+="$x,false"
    }
    else
    {
        $reachableServerCount++
        $serverResultList += "$x,true"
    }
}
