# not null validations
if (($Variable1.length -lt 1) -or ($Variable2.length -lt 1) -or ($Variable3.length -lt 1)) 
{
            Throw "Error: One or more required parameters is Null."
}

# range validation
if (!($variable1 -match "\b(?:1[0-2]|[1-9])\b")) 
{
    Throw "Error: parameter is not within range."
}

# enum validation
if (!($variable1 -match "\bblue\b|\bred\b")) 
{
    Throw "Error: parameter does not have a valid value."
}

# email address validation
if (!($variable1 -match "^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$")) 
{
    Throw "Error: parameter is not a valid email address."
} 

# date validation
if (!($variable1 -match "^(19|20)\d\d[- /.](0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])$")) 
{
    Throw "Error: parameter is not a valid date."
} 

# IP address validation
if (($test -match "\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b")) 
{
    Throw "Error: parameter is not a valid IP address."
} 
