# create XML file
$path = "{Directory Path from "Get Shared State Path"}"
$filePath = $path + "\SharedState.xml"
$template = "<xml><Request ID='' Status='' StatusText=''/></xml>"
[xml]$xml = $template
$xml.xml.Request.ID = 'SR12345'
$xml.xml.Request.Status = '0'
$xml.xml.Request.StatusText = 'Submitted'
$xml.Save($filePath)

# non-exclusive read/write
$path = "{Directory Path from "Get Shared State Path"}"
$filePath = $path + "\SharedState.xml"
[xml]$xml = Get-Content '$filePath'
$xml.xml.Request.Status = '1'
$xml.xml.Request.StatusText = 'Approved'
$xml.Save('$filePath') 

# exclusive read/write
$path = "{Directory Path from "Get Shared State Path"}"
$filePath = $path + "\SharedState.xml"
[System.IO.FileStream]$file = [System.io.File]::Open($filepath, 'Open', 'ReadWrite', 'None')
[xml]$xml3 = New-Object System.Xml.XmlDocument
$xml3.Load($file)
$xml3.xml.Request.Status = '6'
Read-Host
#rewind the stream the beginning to overwrite
$file.Position = 0 
$xml3.Save($file)
$file.Close()

#  file open with file locking
$path = "{Directory Path from "Get Shared State Path"}"
$filePath = $path + "\SharedState.xml"
$accessed = $false
$tries = 0
while (!$accessed -and $tries -lt 10)
{
  try
  {
    [System.IO.FileStream]$file = [System.io.File]::Open($filePath, 'Open', 'ReadWrite', 'ReadWrite')
    [xml]$xml3 = New-Object System.Xml.XmlDocument
    $xml3.Load($file)
    $accessed = $true
    #Do Work Here
    $file.Close()
  }
  catch
  {
    $tries++
    sleep(5)
  }
}

# delete file
$path = "{Directory Path from "Get Shared State Path"}"
$filePath = $path + "\SharedState.xml"
$accessed = $false
$tries = 0
while (!$accessed -and $tries -lt 10)
{
  try
  {
    [System.IO.FileStream]$file = [System.io.File]::Open($filePath, 'Open', 'Read', 'None')
    [xml]$xml3 = New-Object System.Xml.XmlDocument
    $xml3.Load($file)
    $accessed = $true
    #Do Work Here
    $file.Close()
    [System.io.File]::Delete($filePath)
  }
  catch
  {
    $tries++
    sleep(5)
  }
}
